import Vue from "vue/dist/vue";
import LayoutBuilder from "./LayoutBuilder.vue";
import store from "./store/index";

Vue.config.productionTip = false;

class App {
  constructor(id, config) {
    this.id = id;
    this.layoutBuilder = document.getElementById(this.id);

    if (this.layoutBuilder && this.layoutBuilder.dataset.url) {
      if (this.layoutBuilder.dataset.url) {
        fetch(this.layoutBuilder.dataset.url, {
          credentials: "include"
        }).then(response => {
          if (response.ok) {
            response.json().then(state => {
              this.init([state, config]);
            });
          }
        });
      } else {
        this.init([config]);
      }
    }
  }

  init(configs) {
    return new Vue({
      store: store(
        Object.assign({}, ...configs, {
          contentTypesOverlayVisibility: false,
          currentlyEditableContentElement: null,
          activeGroupInElementsOverlay: null
        })
      ),
      id: this.id,
      render: h => h(LayoutBuilder)
    }).$mount(`#${this.id}`);
  }
}

export default App;
